// IkWnd.h: interface for the CIkWnd class.
//
//////////////////////////////////////////////////////////////////////
#pragma once


class CIkWnd;

/**
	@ingroup	NpMsgrP2P
	@brief		CIkWnd  ޽Ž   ̺Ʈ ̽
	@author		翵
*/
class _CIkWndHandler
{
public:
	virtual void CALLBACK IkWnd_OnMessage(CIkWnd * pIkWnd, UINT message, WPARAM wParam, LPARAM lParam ) = 0;
};

/**
	@ingroup	NpMsgrP2P
	@brief		񵿱 ó  ޽ť  ̿  ֵ  Ŭ.
	@author		翵
*/
class CIkWnd  
{
public:
	CIkWnd(_CIkWndHandler * pHandler = NULL);
	virtual ~CIkWnd();

	static void sRegisterWindowClass();
	static void sUnRegisterWindowClass();

	void SetWndHandler(_CIkWndHandler * pHandler) { m_pHandler = pHandler; }

	int PostMessage(UINT message, WPARAM wParam = 0, LPARAM lParam = 0);
	BOOL DestroyWindow();
	BOOL Create(LPCSTR szWindowName, HWND hWndParent, UINT uID, LPRECT lpRect = NULL, DWORD dwStyle = 0, DWORD dwExStyle = 0);
	void Invalidate(BOOL bErase = TRUE);

	virtual LRESULT CALLBACK OnWindowMsg( UINT message, WPARAM wParam, LPARAM lParam );

	HWND m_hWnd;

protected:
	static char ms_szWndClassName[32];

	//Processes event notifications sent by the sockets or the layers
	static LRESULT CALLBACK sWindowProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam );

	_CIkWndHandler * m_pHandler;	
};
